# encoding: utf-8

import es, gamethread, effectlib

import psyco
psyco.full()

timebombe_users = {}

sas_timebombe_size = es.ServerVar('sas_timebombe_size', 0, "sas : Rayon du balisage")
sas_timebombe_r = es.ServerVar('sas_timebombe_r', 0, "sas : Couleur Rouge, 0 à 255")
sas_timebombe_v = es.ServerVar('sas_timebombe_v', 0, "sas : Couleur Vert, 0 à 255")
sas_timebombe_b = es.ServerVar('sas_timebombe_b', 0, "sas : Couleur Bleu, 0 à 255")
sas_timebombe_time = es.ServerVar('sas_timebombe_time', 0, "sas : Temps avant que le joueur n'explose")

class Timebombe:
    def __init__(self, userid):
        self.repeat = 0
        self.delay = 0
        self.userid = int(userid)
        self.sound = "sas/sas_timebombe.wav"
        self.model = "materials/sprites/lgtning.vmt"        
        self.color = "%d %d %d 255" % (int(sas_timebombe_r), int(sas_timebombe_v), int(sas_timebombe_b))
        self.Type = "Normal"
        self.Function = None
        self.time = sas_timebombe_time
       
    def Start(self, delay=1, repeat = "INDEFINITELY"):
        self.delay = delay
        self.repeat = repeat
        gamethread.delayedname(delay, str(self.userid) + '_timebombe', self.Loop)
   
    def Stop(self, delete = False):
        self.repeat = 0
        self.delay = 0
        gamethread.cancelDelayed(str(self.userid) + '_timebombe')
        Delete(self.userid)
        self.time = sas_timebombe_time
       
    def Loop(self):
        if not self.repeat == "INDEFINITELY" and self.repeat > 0:
            self.repeat -= 1
        elif not self.repeat == "INDEFINITELY":
            self.Stop(True)
            return
        if not es.getplayerprop(self.userid, 'CBasePlayer.pl.deadflag'):
            if self.Type == "Easy":
                es.centermsg(self.time)
                if self.time != 0 :
                    r, g, b, a = str(self.color).split(' ')
                    location = es.getplayerlocation(self.userid)
                    effectlib.drawCircle(location, 150, steps=50, model=self.model, seconds=0.2, width=20, endwidth=10, red=r, green=g, blue=b, brightness = a, speed=70)
                    if self.sound:
                        es.emitsound('player', self.userid, self.sound, 1.0, 0.7)
                    self.time = self.time - 1
                else:
                    es.emitsound('player', int(self.userid), 'sas/sas_player_scream.wav', 1.0, 0.7)
                    es.server.queuecmd('es_xtrick entity env_explosion')
                    location_joueur_x = 0
                    location_joueur_y = 0
                    location_joueur_z = 0
                    location_joueur_x,location_joueur_y,location_joueur_z = es.getplayerlocation(int(self.userid))
                    es.effect('sparks', es.createvectorstring(location_joueur_x,location_joueur_y,float(location_joueur_z + 70.000000), 100, 3, '0,0,0'))
                    es.server.queuecmd('es_xfire %s env_explosion addoutput "origin %s %s %s"' % (self.userid, location_joueur_x, location_joueur_y, location_joueur_z))
                    es.server.queuecmd('es_xfire %s env_explosion addoutput "imagnitude 200"' % self.userid)
                    es.server.queuecmd('es_xfire %s env_explosion addoutput "iradiusoverride 96"' % self.userid)
                    explosion = es.createentitylist('env_explosion')
                    for identite in explosion:
                        es.setindexprop(identite, 'CBaseEntity.m_hOwnerEntity', str(es.getplayerhandle(int(self.userid))))
                    es.server.queuecmd('es_xfire %s env_explosion Explode' % self.userid)
                    es.emitsound('player', int(self.userid), "sas/sas_player_explose.wav", 1.0, 0.7)
            elif self.Type == "Normal":
                if callable(self.Function):
                    self.Function(self.userid)
                else:
                    es.doblock(self.Function)
            gamethread.delayedname(self.delay, str(self.userid) + '_timebombe', self.Loop)
        else:
            self.Stop(True)
           
    def Delete(self):
        self.Stop(True)

def EasyTimebombe(userid):
    userid = int(userid)
    if not timebombe_users.has_key(userid):
        timebombe_users[userid] = Timebombe(userid)
        timebombe_users[userid].Type = "Easy"
    return timebombe_users[userid]
   
def Delete(userid):
    userid = int(userid)
    if not timebombe_users.has_key(userid):
        es.dbgmsg(0, 'ERROR: Cannot find instance %s inside timebombe'%userid)
    else:
        gamethread.cancelDelayed(str(userid) + '_timebombe')
        del timebombe_users[userid]
        
selfmodule = __import__('timebombelib')

def player_disconnect(ev):
    userid = ev['userid']
    if timebombe_users.has_key(userid):
        gamethread.cancelDelayed(str(userid) + '_timebombe')
        Delete(userid)
es.addons.registerForEvent(selfmodule, 'player_disconnect', player_disconnect)
       
def player_death(ev):
    userid = ev['userid']
    if timebombe_users.has_key(userid):
        gamethread.cancelDelayed(str(userid) + '_timebombe')
        Delete(userid)
es.addons.registerForEvent(selfmodule, 'player_death', player_death)
       
def round_end(ev):
    for userid in es.getUseridList():
        if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
            userid = int(userid)
            if timebombe_users.has_key(userid):
                Delete(userid)
es.addons.registerForEvent(selfmodule, 'round_end', round_end)

def server_cvar(event_var):
    if event_var['cvarname'] == 'mp_restartgame' and int(event_var['cvarvalue']) == 1:
        for userid in timebombe_users.keys():
            gamethread.cancelDelayed(str(userid) + '_timebombe')
            Delete(userid)
es.addons.registerForEvent(selfmodule, 'server_cvar', server_cvar)

def round_start(event_var):
    for userid in timebombe_users.keys():
        gamethread.cancelDelayed(str(userid) + '_timebombe')
        Delete(userid)
es.addons.registerForEvent(selfmodule, 'round_start', round_start)
