# encoding: utf-8
import es, gamethread, effectlib, playerlib

import psyco
psyco.full()

timefreeze_users = {}

sas_timefreeze_size = es.ServerVar('sas_timefreeze_size', 0, "sas : Rayon du balisage")
sas_timefreeze_r = es.ServerVar('sas_timefreeze_r', 0, "sas : Couleur Rouge, 0 à 255")
sas_timefreeze_v = es.ServerVar('sas_timefreeze_v', 0, "sas : Couleur Vert, 0 à 255")
sas_timefreeze_b = es.ServerVar('sas_timefreeze_b', 0, "sas : Couleur Bleu, 0 à 255")
sas_timefreeze_time = es.ServerVar('sas_timefreeze_time', 0, "sas : Temps avant que le joueur n'explose")

class Timefreeze:
    def __init__(self, userid):
        self.repeat = 0
        self.delay = 0
        self.userid = int(userid)
        self.sound = "sas/sas_timebombe.wav"
        self.model = "materials/sprites/lgtning.vmt"        
        self.color = "%d %d %d 255" % (int(sas_timefreeze_r), int(sas_timefreeze_v), int(sas_timefreeze_b))
        self.Type = "Normal"
        self.Function = None
        self.time = sas_timefreeze_time
        self.color_r = 0
        self.color_v = 235
        self.color_b = 250
        self.freeze = 1
       
    def Start(self, delay=1, repeat = "INDEFINITELY"):
        self.delay = delay
        self.repeat = repeat
        gamethread.delayedname(delay, str(self.userid) + '_timefreeze', self.Loop)
   
    def Stop(self, delete = False):
        joueur = playerlib.getPlayer(self.userid)
        self.repeat = 0
        self.delay = 0
        gamethread.cancelDelayed(str(self.userid) + '_timefreeze')
        Delete(self.userid)
        self.time = sas_timefreeze_time
        es.emitsound('player', self.userid, 'sas/sas_freeze.wav', 0.0, 0.0)
        joueur.set("freeze", 0)
        joueur.set("color", [255, 255, 255, 255])
        joueur.set("speed", 1)
    def Loop(self):
        if not self.repeat == "INDEFINITELY" and self.repeat > 0:
            self.repeat -= 1
        elif not self.repeat == "INDEFINITELY":
            self.Stop(True)
            return

        joueur = playerlib.getPlayer(self.userid)
        
        if not es.getplayerprop(self.userid, 'CBasePlayer.pl.deadflag'):
            if self.Type == "Easy":
                es.centermsg(self.time)
                if self.time != 0:
                    es.emitsound('player', self.userid, 'sas/sas_freeze.wav', 1.0, 0.7)
                    r, g, b, a = str(self.color).split(' ')
                    location = es.getplayerlocation(self.userid)
                    effectlib.drawCircle(location, 150, steps=50, model=self.model, seconds=0.2, width=20, endwidth=10, red=r, green=g, blue=b, brightness = a, speed=70)
                    if self.sound:
                        es.emitsound('player', self.userid, self.sound, 1.0, 0.7)
                    self.time = self.time - 1
                    self.color_v = int(self.color_v - 10)
                    self.color_b = int(self.color_b - 10)
                    joueur.set("color", [int(self.color_r), int(self.color_v), int(self.color_b), 255])
                    if self.time <= 10:
                        self.freeze = float(self.freeze - 0.1)
                        if self.freeze > float(1.0):
                            self.freeze = float(0.00)
                        joueur.set("speed", str(self.freeze))
                else:
                    joueur.set("freeze", 1)
                    joueur.set("speed", 1)
                    if timefreeze_users.has_key(self.userid):
                        gamethread.cancelDelayed(str(self.userid) + '_timefreeze')
            elif self.Type == "Normal":
                if callable(self.Function):
                    self.Function(self.userid)
                else:
                    es.doblock(self.Function)
            gamethread.delayedname(self.delay, str(self.userid) + '_timefreeze', self.Loop)
        else:
            self.Stop(True)
           
    def Delete(self):
        self.Stop(True)

def EasyTimefreeze(userid):
    userid = int(userid)
    if not timefreeze_users.has_key(userid):
        timefreeze_users[userid] = Timefreeze(userid)
        timefreeze_users[userid].Type = "Easy"
    return timefreeze_users[userid]
   
def Delete(userid):
    userid = int(userid)
    if not timefreeze_users.has_key(userid):
        es.dbgmsg(0, 'ERROR: Cannot find instance %s inside timefreeze'%userid)
    else:
        gamethread.cancelDelayed(str(userid) + '_timefreeze')
        del timefreeze_users[userid]

selfmodule = __import__('timefreezelib')

def player_disconnect(ev):
    userid = ev['userid']
    if timefreeze_users.has_key(userid):
        gamethread.cancelDelayed(str(userid) + '_timefreeze')
        Delete(userid)
es.addons.registerForEvent(selfmodule, 'player_disconnect', player_disconnect)
       
def player_death(ev):
    userid = ev['userid']
    if timefreeze_users.has_key(userid):
        gamethread.cancelDelayed(str(userid) + '_timefreeze')
        Delete(userid)
es.addons.registerForEvent(selfmodule, 'player_death', player_death)
       
def round_end(ev):
    for userid in es.getUseridList():
        if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
            userid = int(userid)
            if timefreeze_users.has_key(userid):
                Delete(userid)
es.addons.registerForEvent(selfmodule, 'round_end', round_end) 

def server_cvar(event_var):
    if event_var['cvarname'] == 'mp_restartgame' and int(event_var['cvarvalue']) == 1:
        for userid in timefreeze_users.keys():
            gamethread.cancelDelayed(str(userid) + '_timefreeze')
            Delete(userid)
es.addons.registerForEvent(selfmodule, 'server_cvar', server_cvar)

def round_start(event_var):
    for userid in timefreeze_users.keys():
        gamethread.cancelDelayed(str(userid) + '_timefreeze')
        Delete(userid)
es.addons.registerForEvent(selfmodule, 'round_start', round_start)
